/*
 * All Rights Reserved.
 * Copyright (C) 1999-2005 Tsukuba Bunko.
 *
 * Licensed under the BSD License ("the License"); you may not use
 * this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.tsukuba-bunko.org/licenses/LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Id: AudioClip.java,v 1.2 2005/08/19 03:18:11 ppoi Exp $
 */
package tsukuba_bunko.peko.canvas.stage;

import	java.net.URL;


/**
 * yNbv̊{Iȋ@\񋟂܂B
 * @author	$Author: ppoi $
 * @version	$Revision: 1.2 $ $Date: 2005/08/19 03:18:11 $
 */
public abstract class AudioClip	{

	/**
	 * Nbv ID
	 */
	private String	_id = null;

	/**
	 * ̃NbvǗ AudioPlayer
	 */
	private AudioPlayer	_player = null;

	/**
	 * ĐNbv URL
	 */
	private URL	_clipURL = null;

	/**
	 * [v邩ǂ
	 */
	private boolean	_isLoop = false;


	/**
	 * <code>AudioClip</code> ̃CX^X쐬邽߂ɃTuNX̃RXgN^Ă΂܂B
	 * @param	id	Nbv ID
	 * @param	clipURL	Nbv URL
	 */
	protected AudioClip( String id, URL clipURL )
	{
		super();
		_id = id;
		_clipURL = clipURL;
	}


	/**
	 * ̃NbṽNbv ID 擾܂B
	 * @return	Nbv ID
	 */
	public String getID()
	{
		return _id;
	}

	/**
	 * ̃NbvǗ AudioPlayer ݒ肵܂B
	 * @param	player	̃NbvǗ AudioPlayer
	 */
	public void setAudioPlayer( AudioPlayer player )
	{
		_player = player;
	}

	/**
	 * ̃NbvǗ AudioPlayer 擾܂B
	 * @return	̃NbvǗ AudioPlayer
	 */
	public AudioPlayer getAudioPlayer()
	{
		return _player;
	}

	/**
	 * ̃Nbṽ\[Xf[^ URL 擾܂B
	 * @return	̃Nbṽ\[Xf[^ URL
	 */
	public URL getClipURL()
	{
		return _clipURL;
	}

	/**
	 * ̃Nbv̍Đ[v邩ǂ𔻒肵܂B
	 * @return	[vꍇ <code>true</code>AȂꍇ <code>false</code>
	 */
	public boolean isLoop()
	{
		return _isLoop;
	}

	/**
	 * ̃NbvĐJn܂B
	 * @param	loop	[vꍇ <code>true</code>AȂꍇ <code>false</code>B
	 */
	public void play( boolean loop )
	{
		_isLoop = loop;
		play();
	}

	/**
	 * ̃Nbv̍ĐJn܂B
	 */
	public abstract void play();

	/**
	 * ̃Nbv̍Đ~܂B
	 */
	public void stop()
	{
		stop( AudioPlayer.STOP_WITH_SYNC_FADEOUT );
	}

	/**
	 * ̃Nbv̍Đ~܂B
	 * @param	mode	~[h
	 */
	public abstract void stop( int mode );

	/**
	 * tIƂ AudioPlayer ɒʒm܂B
	 */
	protected void playingFinished()
	{
		AudioPlayer	player = getAudioPlayer();
		if( player != null )	{
			player.unregister( this );
		}
	}
}
