/*
 * All Rights Reserved.
 * Copyright (C) 1999-2005 Tsukuba Bunko.
 *
 * Licensed under the BSD License ("the License"); you may not use
 * this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.tsukuba-bunko.org/licenses/LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Id: Resources.java,v 1.2 2005/07/24 20:55:57 ppoi Exp $
 */
package tsukuba_bunko.resource;

import	java.io.IOException;

import	java.net.URL;

import	java.util.Map;

import	javax.xml.parsers.ParserConfigurationException;

import	org.xml.sax.SAXException;


/**
 * \[Xƃ\[XID̊֘AǗ܂B
 * @author	$Author: ppoi $
 * @version	$Revision: 1.2 $
 */
public class Resources	{

	/**
	 * \[X
	 */
	private Map	_resources = null;


	/**
	 * <code>Resources</code> ̃CX^X쐬܂B
	 */
	public Resources()
	{
		_resources = new java.util.HashMap( 89 );
	}


	/**
	 * \[X擾܂B
	 * @param	resourceName	\[X
	 * @return	\[X
	 */
	public Object getResource( String resourceName )
	{
		return _resources.get( resourceName );
	}

	/**
	 * \[Xݒ肵܂B
	 * @param	resourceName	\[X
	 * @param	resource	\[X
	 */
	public final void setResource( String resourceName, Object resource )
	{
		_resources.put( resourceName, resource );
	}

	/**
	 *  <code>Resources</code> ǗS\[XID擾܂B
	 * @return	\[XID̔z
	 */
	public String[] getResourceIDs()
	{
		return (String[])_resources.keySet().toArray( new String[_resources.size()] );
	}

	/**
	 * \[Xt@C烊\[X[hA<code>Resources</code> ̃CX^X쐬܂.
	 * @param	resourceURL	\[Xt@C URL
	 * @return	ꂽ <code>Resources</code>
	 * @throws	IllegalResourceException	\[Xt@Csȏꍇ
	 * @throws	ParserConfigurationException	JAXP ɍ\ĂȂꍇ
	 * @throws	SAXException	JAXP ɍ\ĂȂꍇ
	 * @throws	IOException	I/O G[ꍇ
	 */
	public static Resources newInstance( URL resourceURL )
		throws IllegalResourceException, ParserConfigurationException, SAXException, IOException
	{
		Resources	resources = new Resources();
		ResourceLoader	loader = new ResourceLoader();
		loader.loadResource( resourceURL, resources );
		return resources;
	}
}